'Bin2Hex creates a hex string representing the
'binary data in a file. The hex data is saved 
'in a text file named after this script. For 
'example, assume the name of this script (you 
'can rename the wscript) is "Bin2Hex.vbs". If
'if you had a file named "ra.gif" and passed 
'it to this script, it would APPEND to a file 
'named "Bin2Hex.txt" the data:
'strRA = "47494638396110001000B300009C6634FCCE
'... and so on. Only part of the above line is 
'shown. The script only handles one file at a 
'time. To handle all files in a folder, use a 
'command line like this:
'for %x in (*.gif) do bin2hex.vbs %x

Dim fs, ts, wsh
Dim strLine, strName, strPrompt
Dim blnFirstTime
Dim varByteArray
Dim intPos, lngCounter
Const BYTES_PER_LINE = 250
Const ForWriting = 2
Const ForAppending = 8
Set wsh = CreateObject("Wscript.Shell")
Set fs = CreateObject("Scripting.FileSystemObject")

'Verify we have a good argument
If WScript.Arguments.Count <> 1 Then
	WScript.Echo "Pass a file as an argument. The file will be read into hex data. Read the comments in this script for more information."
	WScript.Quit 1
End If
If Not fs.FileExists(WScript.Arguments(0)) Then
	WScript.Echo "The argument you supplied does not exist as a file."
	WScript.Quit 1
End If

'Verify we have the ADODB.Stream object available
If Not IsRegistered("ADODB.Stream") Then
	WScript.Echo "ADODB is not installed on your system. Please install the latest Microsoft data access components from www.microsoft.com/data."
	WScript.Quit
End If

'Read the source file
varByteArray = ReadByteArray(WScript.Arguments(0))
'Begin writing the output file
Set ts = fs.OpenTextFile(FileNameLikeMine("txt"), ForAppending, True)
intPercent = 0

'Now read every byte in the file and spit out hex
strLine = ""
blnFirstTime = True
strName = fs.GetBaseName(Wscript.Arguments(0))
strName = UCase(strName)
If InStr(strName, ".") > 1 Then
	strName = Left(strName, InStr(strName, ".") - 1)
End If
strName = "str" & strName
For lngCounter = 1 to UBound(varByteArray) + 1
	strLine = strLine & Right("00" & Hex(Ascb(Midb(varByteArray,lngCounter,1))), 2)
	If lngCounter Mod BYTES_PER_LINE = 0 Then
		'write the accumulated data line
		If blnFirstTime Then
			ts.WriteLine strName & " = """ & strLine & """"
			blnFirstTime = False
		Else
			ts.WriteLine strName & " = " & strName & " & """ & strLine & """"
		End If
		strLine = ""
	End If
Next

'Handle leftovers
If strLine <> "" Then 
	'write the accumulated data line
	If blnFirstTime Then
		ts.WriteLine strName & " = """ & strLine & """"
		blnFirstTime = False
	Else
		ts.WriteLine strName & " = " & strName & " & """ & strLine & """"
	End If
End If

Function IsRegistered(strObjectName)
'Returns True if object can be created
Dim obj
On Error Resume Next
	Set obj = Nothing
	Set obj = CreateObject(strObjectName)
	If obj Is Nothing Then
		IsRegistered = False
	Else
		IsRegistered = True
		Set obj = Nothing
	End If
End Function

Function ReadByteArray(strFileName)
Const adTypeBinary = 1
Dim bin
	Set bin = CreateObject("ADODB.Stream")
	bin.Type = adTypeBinary
	bin.Open
	bin.LoadFromFile strFileName
	ReadByteArray = bin.Read
End Function

Function FileNameLikeMine(strFileExtension) 'As String
'Returns a file name the same as the script name except
'for the file extension. 
Dim fs 'As Object
Dim strExtension 'As String
	Set fs = CreateObject("Scripting.FileSystemObject")
	strExtension = strFileExtension
	If Len(strExtension) < 1 Then strExtension = "txt"
	If strExtension = "." Then strExtension = "txt"
	If Left(strExtension,1) = "." Then strExtension = Mid(strExtension, 2)
	FileNameLikeMine = Left(Wscript.ScriptFullName, InstrRev(Wscript.ScriptFullName, ".")) & strExtension
End Function

